/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

/* pvfs2_get_attr_sm
 *
 * This state machine handles incoming server getattr operations.  These
 * are the operations sent by PVFS_sys_getattr() among others.
 *
 * The pvfs2_prelude_sm is responsible for reading the actual metadata
 * to begin with, because it does this as part of the permission checking
 * process.
 */

#include <string.h>
#include <assert.h>

#include "server-config.h"
#include "pvfs2-server.h"
#include "pvfs2-attr.h"
#include "pvfs2-types.h"
#include "pvfs2-types-debug.h"

enum
{
    STATE_METAFILE = 7,
    STATE_SYMLINK  = 9
};


static int getattr_cleanup(PINT_server_op *s_op,
                           job_status_s* js_p);
static int getattr_verify_attribs(PINT_server_op *s_op,
                                  job_status_s* js_p);
static int getattr_read_symlink_target(PINT_server_op *s_op,
                                       job_status_s* js_p);
static int getattr_read_metafile_datafile_handles_if_required(
    PINT_server_op *s_op, job_status_s* js_p);
static int getattr_read_metafile_distribution_if_required(
    PINT_server_op *s_op, job_status_s* js_p);
static int getattr_setup_resp(PINT_server_op *s_op,
                              job_status_s* js_p);

extern PINT_server_trove_keys_s Trove_Common_Keys[];

extern union PINT_state_array_values ST_prelude[];
extern union PINT_state_array_values ST_cleanup[];
extern union PINT_state_array_values ST_setup_resp[];
extern union PINT_state_array_values ST_final_response[];
extern union PINT_state_array_values ST_verify_attribs[];
extern union PINT_state_array_values ST_read_symlink_target[];
extern union PINT_state_array_values ST_read_metafile_datafile_handles_if_required[];
extern union PINT_state_array_values ST_read_metafile_distribution_if_required[];

struct PINT_state_machine_s pvfs2_get_attr_sm =
{
	ST_prelude,
	"pvfs2_get_attr_sm"
};
static union PINT_state_array_values ST_prelude[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_prelude_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_verify_attribs,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_verify_attribs[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) getattr_verify_attribs,
(union PINT_state_array_values) STATE_SYMLINK,
(union PINT_state_array_values) ST_read_symlink_target,
(union PINT_state_array_values) STATE_METAFILE,
(union PINT_state_array_values) ST_read_metafile_datafile_handles_if_required,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_setup_resp
};

static union PINT_state_array_values ST_read_symlink_target[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) getattr_read_symlink_target,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_setup_resp
};

static union PINT_state_array_values ST_read_metafile_datafile_handles_if_required[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) getattr_read_metafile_datafile_handles_if_required,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_read_metafile_distribution_if_required
};

static union PINT_state_array_values ST_read_metafile_distribution_if_required[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) getattr_read_metafile_distribution_if_required,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_setup_resp
};

static union PINT_state_array_values ST_setup_resp[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) getattr_setup_resp,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_final_response[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_final_response_sm,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_cleanup
};

static union PINT_state_array_values ST_cleanup[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) getattr_cleanup,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_prelude
};

# 111 "src/server/get-attr.sm"


/* getattr_verify_attribs()
 *
 * We initialize the attribute mask that will be returned in this function.
 * This mask can be augmented in some of the other states.
 */
static int getattr_verify_attribs(PINT_server_op *s_op, job_status_s* js_p)
{
    PVFS_object_attr *a_p = NULL;

    PINT_STATE_DEBUG("verify_attribs");

    /* copy basic attributes structure into response */
    s_op->resp.u.getattr.attr = s_op->attr;
    a_p = &s_op->resp.u.getattr.attr;

    gossip_debug(SERVER_DEBUG,
		 "  attrs read from dspace = (owner = %d, group = %d, "
                 "perms = %o, type = %d, atime = %lld, mtime = %lld, "
                 "ctime = %lld | dfile_count=%d | dist_size = %d)\n",
		 a_p->owner,
		 a_p->group,
		 a_p->perms,
		 a_p->objtype,
		 (long long)a_p->atime,
		 (long long)a_p->mtime,
		 (long long)a_p->ctime,
                 (int)a_p->u.meta.dfile_count,
                 (int)a_p->u.meta.dist_size);

    gossip_debug(SERVER_DEBUG, "mask output from getattr: ");
    PINT_attrmask_print(SERVER_DEBUG, s_op->attr.mask);

    js_p->error_code = 0;

    if (a_p->objtype == PVFS_TYPE_METAFILE)
    {
	gossip_debug(SERVER_DEBUG,
		     "  handle %Lu refers to a metafile\n",
		     Lu(s_op->req->u.getattr.handle));

	a_p->mask = PVFS_ATTR_COMMON_ALL;

        if (s_op->req->u.getattr.attrmask & PVFS_ATTR_META_DFILES)
        {
            gossip_debug(SERVER_DEBUG, " dspace has dfile_count of %d\n",
                         s_op->attr.u.meta.dfile_count);

            /* copy over the dfile count for reading later */
            a_p->u.meta.dfile_count = s_op->attr.u.meta.dfile_count;

            a_p->mask |= PVFS_ATTR_META_DFILES;
        }

        if (s_op->req->u.getattr.attrmask & PVFS_ATTR_META_DIST)
        {
            gossip_debug(SERVER_DEBUG, " dspace has dist size of %d\n",
                         s_op->attr.u.meta.dist_size);

            /* copy over the dist size for reading later */
            a_p->u.meta.dist_size = s_op->attr.u.meta.dist_size;

            a_p->mask |= PVFS_ATTR_META_DIST;
        }

        if (a_p->mask != PVFS_ATTR_COMMON_ALL)
        {
            js_p->error_code = STATE_METAFILE;
        }
    }
    else if (a_p->objtype == PVFS_TYPE_DATAFILE)
    {
	gossip_debug(SERVER_DEBUG, "  handle %Lu refers to "
                     "a datafile.\n", Lu(s_op->req->u.getattr.handle));

        /*
          note: the prelude already retrieved the size for us,
          so there's no special action that needs to be taken
          if we have a datafile here
        */
        a_p->mask = PVFS_ATTR_COMMON_TYPE | PVFS_ATTR_DATA_ALL;
    }
    else if (a_p->objtype == PVFS_TYPE_DIRECTORY)
    {
	gossip_debug(SERVER_DEBUG, "  handle %Lu refers to "
                     "a directory. doing nothing special\n",
		     Lu(s_op->req->u.getattr.handle));
	a_p->mask = PVFS_ATTR_COMMON_ALL;
    }
    else if (a_p->objtype == PVFS_TYPE_DIRDATA)
    {
	gossip_debug(SERVER_DEBUG, "  handle %Lu refers to "
                     "a dirdata object. doing nothing special\n",
		     Lu(s_op->req->u.getattr.handle));
        a_p->mask = PVFS_ATTR_COMMON_ALL;
    }
    else if (a_p->objtype == PVFS_TYPE_SYMLINK)
    {
	gossip_debug(SERVER_DEBUG,
                     "  handle %Lu refers to a symlink.\n",
                     Lu(s_op->req->u.getattr.handle));

	a_p->mask = PVFS_ATTR_COMMON_ALL;

        js_p->error_code = STATE_SYMLINK;
    }
    else
    {
	gossip_debug(SERVER_DEBUG, "  handle %Lu refers to something "
                     "unknown -- assuming datafile!\n",
                     Lu(s_op->req->u.getattr.handle));

        a_p->objtype = PVFS_TYPE_DATAFILE;
        a_p->mask = PVFS_ATTR_COMMON_TYPE | PVFS_ATTR_DATA_ALL;
    }
    return 1;
}

static int getattr_read_symlink_target(PINT_server_op *s_op, job_status_s* js_p)
{
    int ret;
    job_id_t i;

    PINT_STATE_DEBUG("read_symlink_target");

    /* if we don't need to fill in the symlink target, skip it */
    if (!(s_op->req->u.getattr.attrmask & PVFS_ATTR_SYMLNK_TARGET))
    {
        gossip_debug(SERVER_DEBUG, "skipping symlink target read\n");
        js_p->error_code = 0;
        return 1;
    }

    s_op->key.buffer    = Trove_Common_Keys[SYMLINK_TARGET_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[SYMLINK_TARGET_KEY].size;

    /* add mask value to indicate the distribution is filled */
    s_op->resp.u.getattr.attr.mask |= PVFS_ATTR_SYMLNK_TARGET;

    s_op->resp.u.getattr.attr.u.sym.target_path_len = PVFS_NAME_MAX;
    s_op->resp.u.getattr.attr.u.sym.target_path =
	malloc(s_op->resp.u.getattr.attr.u.sym.target_path_len);
    if (!s_op->resp.u.getattr.attr.u.sym.target_path)
    {
	js_p->error_code = -PVFS_ENOMEM;
	return(1);
    }

    s_op->val.buffer    = s_op->resp.u.getattr.attr.u.sym.target_path;
    s_op->val.buffer_sz = s_op->resp.u.getattr.attr.u.sym.target_path_len;

    ret = job_trove_keyval_read(
        s_op->req->u.getattr.fs_id,
        s_op->req->u.getattr.handle,
        &(s_op->key),
        &(s_op->val),
        0,
        NULL,
        s_op,
        0,
        js_p,
        &i,
        server_job_context);

    return ret;
}


/* getattr_read_metafile_datafile_handles_if_required
 */
static int getattr_read_metafile_datafile_handles_if_required(
    PINT_server_op *s_op, job_status_s* js_p)
{
    int dfile_count;
    int ret;
    job_id_t i;

    PINT_STATE_DEBUG("read_metafile_datafile_handles_if_required");

    assert(s_op->attr.objtype == PVFS_TYPE_METAFILE);

    /* if we don't need to fill in the dfiles, skip them */
    if (!(s_op->req->u.getattr.attrmask & PVFS_ATTR_META_DFILES))
    {
        gossip_debug(SERVER_DEBUG, "skipping data handle read\n");
        js_p->error_code = 0;
        return 1;
    }

    dfile_count = s_op->attr.u.meta.dfile_count;

    gossip_debug(SERVER_DEBUG,
                 " request has dfile_count of %d | dspace has %d\n",
                 s_op->resp.u.getattr.attr.u.meta.dfile_count,
                 s_op->attr.u.meta.dfile_count);

    /* verify that the retrieved dfile count is sane */
    if (!PVFS_REQ_LIMIT_DFILE_COUNT_IS_VALID(dfile_count))
    {
        gossip_err("The requested dfile count of %d is invalid; "
                   "aborting operation.\n", dfile_count);
	js_p->error_code = -PVFS_EOVERFLOW;
        assert(0);
	return 1;
    }

    s_op->key.buffer    = Trove_Common_Keys[METAFILE_HANDLES_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[METAFILE_HANDLES_KEY].size;

    /* add mask value to indicate the data file array is filled */
    s_op->resp.u.getattr.attr.mask |= PVFS_ATTR_META_DFILES;

    /* NOTE: ALLOCATING MEMORY HERE */
    s_op->resp.u.getattr.attr.u.meta.dfile_array =
        malloc(dfile_count * sizeof(PVFS_handle));
    if (!s_op->resp.u.getattr.attr.u.meta.dfile_array)
    {
	js_p->error_code = -PVFS_ENOMEM;
	return(1);
    }

    s_op->val.buffer    = s_op->resp.u.getattr.attr.u.meta.dfile_array;
    s_op->val.buffer_sz = (dfile_count * sizeof(PVFS_handle));

    gossip_debug(SERVER_DEBUG,
		 "  reading %d datafile handles (coll_id = 0x%x, "
                 "handle = %Lu, key = %s (%d), val_buf = %p (%d))\n",
		 dfile_count,
		 s_op->req->u.getattr.fs_id,
		 Lu(s_op->req->u.getattr.handle),
		 (char *) s_op->key.buffer,
		 s_op->key.buffer_sz,
		 s_op->val.buffer,
		 s_op->val.buffer_sz);

    ret = job_trove_keyval_read(
        s_op->req->u.getattr.fs_id,
        s_op->req->u.getattr.handle,
        &s_op->key,
        &s_op->val,
        0,
        NULL,
        s_op,
        0,
        js_p,
        &i,
        server_job_context);

    return ret;
}

/* getattr_read_metafile_distribution_if_required
 */
static int getattr_read_metafile_distribution_if_required(
    PINT_server_op *s_op, job_status_s* js_p)
{
    int ret;
    job_id_t i;

    PINT_STATE_DEBUG("read_metafile_distribution_if_required");

    /* if we don't need to fill in the distribution, skip it */
    if (!(s_op->req->u.getattr.attrmask & PVFS_ATTR_META_DIST))
    {
        gossip_debug(SERVER_DEBUG, "skipping data handle "
                     "distribution read\n");
        js_p->error_code = 0;
        return 1;
    }

    s_op->key.buffer    = Trove_Common_Keys[METAFILE_DIST_KEY].key;
    s_op->key.buffer_sz = Trove_Common_Keys[METAFILE_DIST_KEY].size;

    /* should be some distribution information. */
    assert(s_op->resp.u.getattr.attr.u.meta.dist_size > 0);

    /* add mask value to indicate the distribution is filled */
    s_op->resp.u.getattr.attr.mask |= PVFS_ATTR_META_DIST;

    /* NOTE: allocating memory here, free'd in last state */
    s_op->resp.u.getattr.attr.u.meta.dist =
	malloc(s_op->resp.u.getattr.attr.u.meta.dist_size);
    if(!s_op->resp.u.getattr.attr.u.meta.dist)
    {
	js_p->error_code = -PVFS_ENOMEM;
	return(1);
    }

    s_op->val.buffer    = s_op->resp.u.getattr.attr.u.meta.dist;
    s_op->val.buffer_sz = s_op->resp.u.getattr.attr.u.meta.dist_size;

    ret = job_trove_keyval_read(
        s_op->req->u.getattr.fs_id,
        s_op->req->u.getattr.handle,
        &(s_op->key),
        &(s_op->val),
        0,
        NULL,
        s_op,
        0,
        js_p,
        &i,
        server_job_context);

    return ret;
}

/* getattr_setup_resp()
 *
 * fills in the response structure based on results of previous 
 * operations
 */
static int getattr_setup_resp(PINT_server_op *s_op, job_status_s* js_p)
{
    PVFS_object_attr *a_p;

    PINT_STATE_DEBUG("setup_resp");

    a_p = &s_op->resp.u.getattr.attr;
    
    /* TODO: figure out if we need a different packing mechanism here */
    if ((a_p->objtype == PVFS_TYPE_METAFILE) &&
        (a_p->mask & PVFS_ATTR_META_DIST))
    {
        PINT_Dist_decode(a_p->u.meta.dist, NULL);
    }

    gossip_debug(SERVER_DEBUG,
		 "  sending attrs (owner = %d, group = %d, perms = %o, "
		 "type = %d, atime = %lld, mtime = %lld, ctime = %lld)\n",
		 a_p->owner,
		 a_p->group,
		 a_p->perms,
		 a_p->objtype,
		 (long long)a_p->atime,
		 (long long)a_p->mtime,
		 (long long)a_p->ctime);

    if ((a_p->objtype == PVFS_TYPE_METAFILE) &&
        (a_p->mask & PVFS_ATTR_META_DFILES))
    {
	gossip_debug(SERVER_DEBUG,
		     "  also returning %d datafile handles\n",
		     a_p->u.meta.dfile_count);
    }
    if ((a_p->objtype == PVFS_TYPE_METAFILE) &&
        (a_p->mask & PVFS_ATTR_META_DIST))
    {
	gossip_debug(SERVER_DEBUG,
		     "  also returning dist size of %d\n",
		     a_p->u.meta.dist_size);
    }

    if ((a_p->objtype == PVFS_TYPE_DATAFILE) &&
        (a_p->mask & PVFS_ATTR_DATA_SIZE))
    {
        if (js_p->error_code != 0)
        {
            gossip_err("*** dspace size read failed.\n");
        }
        else
        {
            /* assign properly retrieved size value to response */
            a_p->u.data.size = s_op->ds_attr.b_size;

            gossip_debug(SERVER_DEBUG,
                         "  also returning data size of %Ld\n",
                         Ld(a_p->u.data.size));
        }
    }

    if ((a_p->objtype == PVFS_TYPE_SYMLINK) &&
        (a_p->mask & PVFS_ATTR_SYMLNK_TARGET))
    {
        /*
          adjust target path len down to actual size ; always
          include the null termination char in the target_path_len
        */
        a_p->u.sym.target_path_len = (strlen(a_p->u.sym.target_path) + 1);

        gossip_debug(SERVER_DEBUG,
                     "  also returning link target of %s (len %d)\n",
                     a_p->u.sym.target_path, a_p->u.sym.target_path_len);
    }

    gossip_debug(SERVER_DEBUG,
		 "  sending status %d\n",
		 s_op->resp.status);

    gossip_debug(SERVER_DEBUG, "returning attrmask ");
    PINT_attrmask_print(SERVER_DEBUG, s_op->resp.u.getattr.attr.mask);

    /* NOTE: we _intentionally_ preserve the error_code so that the 
     * following states can use it to set the status field in the
     * response
     */
    return(1);
}


/*
 * Function: getattr_cleanup
 *
 * Params:   server_op *b, 
 *           job_status_s* js_p
 *
 * Pre:      Memory has been allocated
 *
 * Post:     All Allocated memory has been freed.
 *
 * Returns:  int
 *
 * Synopsis: free memory and return
 *           
 */
static int getattr_cleanup(PINT_server_op *s_op, job_status_s* js_p)
{
    PINT_STATE_DEBUG("getattr_cleanup");

    /*
      if this is a metafile, we may have allocated space
      for the datafile handles; free that.
    */
    if (s_op->resp.u.getattr.attr.objtype == PVFS_TYPE_METAFILE)
    {
        if (s_op->resp.u.getattr.attr.mask & PVFS_ATTR_META_DFILES)
            free(s_op->resp.u.getattr.attr.u.meta.dfile_array);

        if (s_op->resp.u.getattr.attr.mask & PVFS_ATTR_META_DIST)
            free(s_op->resp.u.getattr.attr.u.meta.dist);
    }

    if (s_op->resp.u.getattr.attr.objtype == PVFS_TYPE_SYMLINK)
    {
        if (s_op->resp.u.getattr.attr.mask & PVFS_ATTR_SYMLNK_TARGET)
            free(s_op->resp.u.getattr.attr.u.sym.target_path);
    }

    return(server_state_machine_complete(s_op));
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 noexpandtab
 */

