/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */


#include <string.h>
#include <assert.h>

#include "server-config.h"
#include "pvfs2-server.h"
#include "pvfs2-attr.h"

static int mkdir_create(PINT_server_op *s_op, job_status_s* js_p);
static int mkdir_setattrib(PINT_server_op *s_op, job_status_s* js_p);
static int mkdir_cleanup(PINT_server_op *s_op, job_status_s* js_p);
static int mkdir_error(PINT_server_op *s_op, job_status_s* js_p);

extern PINT_server_trove_keys_s Trove_Common_Keys[];

extern union PINT_state_array_values ST_prelude[];
extern union PINT_state_array_values ST_create[];
extern union PINT_state_array_values ST_set_attrib[];
extern union PINT_state_array_values ST_final_response[];
extern union PINT_state_array_values ST_err_msg[];
extern union PINT_state_array_values ST_cleanup[];

struct PINT_state_machine_s pvfs2_mkdir_sm =
{
	ST_prelude,
	"pvfs2_mkdir_sm"
};
static union PINT_state_array_values ST_prelude[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_prelude_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_create,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_create[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) mkdir_create,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_set_attrib,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_err_msg
};

static union PINT_state_array_values ST_set_attrib[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) mkdir_setattrib,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_final_response,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_err_msg
};

static union PINT_state_array_values ST_final_response[] = {
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_final_response_sm,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_cleanup
};

static union PINT_state_array_values ST_err_msg[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) mkdir_error,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_cleanup[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) mkdir_cleanup,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_prelude
};

# 71 "src/server/mkdir.sm"


/*
 * Function: mkdir_create
 *
 * Params:   server_op *s_op, 
 *           job_status_s* js_p
 *
 * Returns:  int
 *
 * Synopsis: 
 *
 * NOTE: returned handle will pop out in js_p->handle (the job status struct).
 */
static int mkdir_create(PINT_server_op *s_op, job_status_s* js_p)
{

    int ret;
    job_id_t i;

    gossip_debug(SERVER_DEBUG, "mkdir state: create\n");

    gossip_debug(
        SERVER_DEBUG, "\ttrying to dspace create on "
        "fs_id %d | handle-range[0]: %Lu-%Lu\n",
        s_op->req->u.mkdir.fs_id,
        Lu(s_op->req->u.mkdir.handle_extent_array.extent_array[0].first),
        Lu(s_op->req->u.mkdir.handle_extent_array.extent_array[0].last));

    ret = job_trove_dspace_create(
        s_op->req->u.mkdir.fs_id,
        &s_op->req->u.mkdir.handle_extent_array,
        PVFS_TYPE_DIRECTORY,
        NULL,
        s_op,
        0,
        js_p,
        &i,
        server_job_context);

    return(ret);
}


/*
 * Function: mkdir_setattrib
 *
 * Params:   server_op *s_op, 
 *           job_status_s* js_p
 *
 * Returns:  int
 *
 * Synopsis: 
 *           
 */
static int mkdir_setattrib(PINT_server_op *s_op, job_status_s* js_p)
{
    int ret = -1;
    job_id_t j_id;
    PVFS_object_attr *a_p = NULL;
    PVFS_ds_attributes *ds_attr = NULL;

    PINT_STATE_DEBUG("setattrib");

    /* save the handle from the create in the response */
    s_op->resp.u.mkdir.handle = js_p->handle;

    a_p = &(s_op->req->u.mkdir.attr);
    gossip_debug(SERVER_DEBUG, "  attrs to write = (owner = %d, "
                 "group = %d, perms = %o, type = %d)\n",
		 a_p->owner, a_p->group, a_p->perms, a_p->objtype);

    /* finally, translate attrs to storage attr format */
    ds_attr = (&s_op->ds_attr);
    PVFS_object_attr_to_ds_attr(a_p, ds_attr);

    ret = job_trove_dspace_setattr(
        s_op->req->u.mkdir.fs_id, s_op->resp.u.mkdir.handle,
        ds_attr, s_op, 0, js_p, &j_id, server_job_context);

    return(ret);
}


/*
 * Function: mkdir_cleanup
 *
 * Params:   server_op *b, 
 *           job_status_s* js_p
 *
 * Returns:  int
 *
 * Synopsis: free memory and return
 *           
 */
static int mkdir_cleanup(PINT_server_op *s_op, job_status_s* js_p)
{
    PINT_STATE_DEBUG("cleanup");

    return(server_state_machine_complete(s_op));
}

/* TODO: fix comment block */
static int mkdir_error(PINT_server_op *s_op, job_status_s* js_p)
{
    PINT_STATE_DEBUG("error");
    s_op->resp.u.mkdir.handle = 0;
    js_p->error_code = -1;
    return(1);
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 noexpandtab
 */

